
// FILE : smll.h											build 6
// =================================================================
// Simple Memory Leak Locator
// =================================================================
// Copyright (c) 2000 by jhkim (neuron)
//
//
// CONTACT TO
// e-mail	: cherishee@hotmail.com
// office	: +82-361-240-1457 (Graphics and Virtual Environment Lab. in Hallym univ.)
// cellular	: 011-9945-2575
//
// NOTE THAT
//		All the following codes are contributed with NO-WARRANTY!!!
//		Please use and modify it freely at your own risk.
//
// HISTORY
//		Read history.txt

#ifndef __SMLL_H__
#define __SMLL_H__

#ifdef __SMLLDEF__

	struct _NEWSTRUCT
	{
		unsigned int size;
		unsigned long line;
		unsigned char *p;
		char *fn;
		int ntype;
		int dtype;
	};

	void* operator new(size_t size, const char *file, unsigned long line);
	void* operator new[](size_t size, const char *file, unsigned long line);
	void operator delete(void *p);
	void operator delete[](void *p);

	void SMLLInit(int autoreport);
	void SMLLReport();
	void* malloc(size_t size, const char *file, unsigned long line);
	void* calloc(size_t num, size_t size, const char *file, unsigned long line);
	void* realloc(void *mem, size_t size, const char *file, unsigned long line);
	void smll_alloc_info(void *ptr, size_t size, const char *file, unsigned long line, int ntype, int dtype);
	void smll_prepare_dealloc(const char *file, unsigned long line);
	void smll_dealloc_info(void *p, const char *file, unsigned long line, int dtype);
	void free(void *p, const char *file, unsigned long line);
	void smll_report();

#ifndef __SMLL_CPP__

	#define new		new(__FILE__, __LINE__)
	#define delete	smll_prepare_dealloc(__FILE__, __LINE__), delete

	#define malloc(s)			malloc(s, __FILE__, __LINE__)
	#define calloc(num,size)	calloc(num, size, __FILE__, __LINE__)
	#define realloc(mem,size)	realloc(mem,size, __FILE__, __LINE__)
	#define	free(p)				free(p, __FILE__, __LINE__)

#endif // __SMLL_CPP__

#else
	#define	SMLLInit(v)
	#define SMLLReport()

#endif // __SMLLDEF__

#endif // __SMLL_H__

